Submit a custom object bulk job
Submits a bulk job request for a bulk operation on the specified custom object records. A succcessful call returns a newly created bulk job. The job ID can be used to poll the job status or upload the CSV file if it is a create or update job.
Limits
This custom object bulk jobs have the following limits:
- The concurrent bulk job limit per tenant is 5. Bulk jobs in
accepted,pending, orin_progressstatus are counted towards the concurrent bulk job limit. - The bulk job execuation order is not guaranteed, which means the bulk job that you submit ealier may be executed later.
- Only the users that have the “Delete Custom Objects” permission can create a
deletebulk job. Only the users that have the “Edit Custom Objects” permission can create acreateorupdatebulk job. See Platform Permissions for more information.
Authentication
Use Bearer {{token}} in the Authorization header for authentication.
Headers
Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.
Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').
An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.
API version that determines the response schema. The default version is used if this parameter is not included. Specify Zuora-Version in the request header if you expect a specific response schema.
Request
The namespace of the object. Custom objects belong to the default namespace. Zuora standard objects belong to the com_zuora namespace. Bulk job operations on the following Zuora standard objects are supported:
- SavedQuery
The operation that the bulk job performs. Only the users that have the “Delete Custom Objects” permission can submit a delete bulk job request. Only the users that have the “Edit Custom Objects” permission can submit a create or update bulk job request. See Platform Permissions for more information.
Response headers
This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
application/jsonapplication/xmltext/htmltext/csvtext/plain
The request limit quota for the time window closest to exhaustion. See rate limits for more information.
The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.
The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.
Response
The namespace of the object. Custom objects belong to the default namespace. Zuora standard objects belong to the com_zuora namespace. Bulk job operations on the following Zuora standard objects are supported:
- SavedQuery
The operation that the bulk job performs. Only the users that have the “Delete Custom Objects” permission can submit a delete bulk job request. Only the users that have the “Edit Custom Objects” permission can submit a create or update bulk job request. See Platform Permissions for more information.
The status of the bulk job:
accepted- The job has been accepted and is ready to process.pending- The job is waiting for your input. You can use Upload a file for a custom object bulk job to upload a file so that the job can start creating records.in_progress- The job is processing.completed- The job has completed.failed- The job was unable to complete. You can use List all errors for a custom object bulk job to list the errors.cancelled- The job was cancelled by the server.